//"diag_dw.sc","DW: diagnostyka dostaw towarw","\System\Diagnostyka\",0,1.0.6,SYSTEM
////////////////////////////
// DW: diagnostyka dostaw towarw
// diag_dw.sc
////////////////////////////

string NAZWA_PLIKU = "DIAG_DW.TXT"
string sRaportDescription

dispatch xConn		// poczenie ADO
dispatch xConnTmp
dispatch xCmdAdo	// instrukcja ADO
dispatch rsDW		// recordset

xConn = GetAdoConnection()
xConnTmp=GetAdoConnection()
xCmdAdo = "ADODB.Command"
xCmdAdo.ActiveConnection = xConn
xCmdAdo.CommandTimeout = 5000

rsDW="ADODB.Recordset"

rsDW.CursorType=1
rsDW.LockType=3

string sSQL
string sAsk, sOut
long lCount
float dIlosc

str.wydruk(0,-1,0)
strona 50,100,50,100

#include "Diagnostyka funkcje"
//--------------------------------------------------------------------------------------------------------------------
sDialogTitle += "dostaw"

StageAddDesc("Raport bada poprawno tabeli dostaw towarw.")

StageAddStage("Sprawdzenie stanw dostaw")
StageAddStage("Sprawdzenie wartoci dostaw")
StageAddStage("Sprawdzenie iloci i daty przyjcia")
StageAddStage("Sprawdzenie ceny dostaw")
StageAddStage("Sprawdzenie dostaw ilociowych")
StageAddStage("Sprawdzenie dostaw przesunicia")
StageAddStage("Sprawdzenie historii dostaw.")
ChooseStages(350)
//--------------------------------------------------------------------------------------------------------------------

int sub funTowary()
	TextOutFun("Sprawdzenie towarw w powizaniach dostaw")
	PopUp(1,"Sprawdzenie towarw w powizaniach dostaw")

	sSQL =  "select distinct DW.id, DW.kod as dwkod, TW.kod "
	sSQL += "from DW join TW on DW.idtw = TW.id "
	sSQL += "join PW on PW.iddw = DW.id "
	sSQL += "where PW.idtw <> DW.idtw"

	rsDW.Open(sSQL,xConn)
	if rsDW.RecordCount() then
		while !rsDW.EOF()
			lCount+=1
			WriteStatusBar(using "Sprawdzenie towarw w powizaniach dostaw...=%d%%%%,255",lCount/rsDW.RecordCount()*100)
			sAsk = using "Istniej powizania z dostaw '%s' towaru '%s' z niewaciwym towarem.", rsDW.Fields("dwkod").Value, rsDW.Fields("kod").Value
			TextOut(sAsk)
			rsDW.MoveNext()
		wend
		if lCount then TextOut("Konieczna diagnostyka tabeli PW")
	endif
	rsDW.Close() : lCount=0
endsub

int sub funStany()
	TextOutFun("Sprawdzenie stanw magazynowych")
	PopUp(1,"Sprawdzenie stanw magazynowych")

	// sprawdzane tylko powizania dla wystawionych dokumentw (typ = 37)
	// omijane dostawy oddziaowe flagDwOddzial 0x02
	sSQL =  "select PWS.stan as pwstan, DW.id, DW.kod as dwkod, TW.kod "
	sSQL += "from DW join TW on DW.idtw = TW.id " 
	sSQL += "join (select -SUM(PW.ilosc) as stan, PW.iddw, PW.idtw from PW where PW.typ = 37 group by PW.iddw, PW.idtw) as PWS on (PWS.iddw = DW.id and PWS.idtw = DW.idtw) "
	sSQL += "where (DW.flag & 0x02) = 0 and CAST(PWS.stan as decimal(24,6)) < 0.0"

	rsDW.Open(sSQL,xConn)
	if rsDW.RecordCount() then
		while !rsDW.EOF()
			lCount+=1
			WriteStatusBar(using "Sprawdzenie stanw magazynowych...=%d%%%%,255",lCount/rsDW.RecordCount()*100)
			sAsk = using "Stan magazynowy '%s' powiza dostawy '%s' o id=%l jest mniejszy od zera.", rsDW.Fields("kod").Value, rsDW.Fields("dwkod").Value, rsDW.Fields("id").Value
			TextOut(sAsk)
			rsDW.MoveNext()
		wend
		if lCount then TextOut("Konieczna diagnostyka tabeli PW")
	endif
	rsDW.Close() : lCount=0

	sSQL =  "select PWS.stan as pwstan, DW.stan as dwstan, DW.id, DW.kod as dwkod, TW.kod "
	sSQL += "from DW join TW on DW.idtw = TW.id " 
	sSQL += "join (select -SUM(PW.ilosc) as stan, PW.iddw, PW.idtw from PW where PW.typ = 37 group by PW.iddw, PW.idtw) as PWS on (PWS.iddw = DW.id and PWS.idtw = DW.idtw) "
	sSQL += "where (DW.flag & 0x02) = 0 and CAST(PWS.stan as decimal(24,6)) >= 0.0 and "
	sSQL += "      CAST((DW.stan - PWS.stan) as decimal(24,6)) <> 0.0"

	rsDW.Open(sSQL,xConn)
	if rsDW.RecordCount() then
		xCmdAdo.ActiveConnection = xConnTmp
		while !rsDW.EOF()
			lCount+=1
			WriteStatusBar(using "Sprawdzenie stanw magazynowych...=%d%%%%,255",lCount/rsDW.RecordCount()*100)
			sAsk = using "Stan towaru '%s' w dostawie '%s' o id=%l wynosi %.6f, a powinien %.6f.", rsDW.Fields("kod").Value, rsDW.Fields("dwkod").Value, rsDW.Fields("id").Value, rsDW.Fields("dwstan").Value, rsDW.Fields("pwstan").Value
			if TextOutAndAsk(1, sAsk," Czy naprawi?") then
				sSQL = using "update DW set stan = %.6f where id = %l", rsDW.Fields("pwstan").Value, rsDW.Fields("id").Value
				xCmdAdo.CommandText = sSQL
				xCmdAdo.Execute()
				TextOut(using "Zmieniono stan towaru '%s' w dostawie '%s'.\n",rsDW.Fields("kod").Value,rsDW.Fields("dwkod").Value)
				TextOut(sRepaired)
			else
				TextOut(sNoRepair)
			endif
			rsDW.MoveNext()
		wend
		xCmdAdo.ActiveConnection = xConn
	endif
	rsDW.Close() : lCount=0

	sSQL =  "select DW.id, DW.kod as dwkod, TW.kod "
	sSQL += "from DW join TW on DW.idtw = TW.id " 
	sSQL += "where (DW.flag & 0x02) = 0 and cast(DW.stan as decimal(24,6)) < 0.0"

	rsDW.Open(sSQL,xConn)
	if rsDW.RecordCount() then
		while !rsDW.EOF()
			lCount+=1
			WriteStatusBar(using "Sprawdzenie stanw magazynowych...=%d%%%%,255",lCount/rsDW.RecordCount()*100)
			sAsk = using "Stan magazynowy '%s' w dostawie '%s' o id=%l jest mniejszy od zera.", rsDW.Fields("kod").Value, rsDW.Fields("dwkod").Value, rsDW.Fields("id").Value
			TextOut(sAsk)
			rsDW.MoveNext()
		wend
		if lCount then TextOut("Konieczna diagnostyka tabeli PW")
	endif
	rsDW.Close() : lCount=0

endsub

int sub funStanyHandlowe()
	TextOutFun("Sprawdzenie stanw handlowych")
	PopUp(1,"Sprawdzenie stanw handlowych")

	// sprawdzane powizania dla rezerwacji (typ = 26)
	// omijane dostawy oddziaowe flagDwOddzial 0x02
	sSQL =  "select (DW.stan - ISNULL(PWR.stan,0.0)) as pwiloscdosp, DW.id, DW.kod as dwkod, TW.kod "
	sSQL += "from DW join TW on DW.idtw = TW.id " 
	sSQL += "left join (select SUM(PW.ilosc) as stan, PW.iddw, PW.idtw from PW where PW.typ = 26 group by PW.iddw, PW.idtw) as PWR on (PWR.iddw = DW.id and PWR.idtw = DW.idtw) "
	sSQL += "where DW.numer > 0 and (DW.flag & 0x02) = 0 and CAST((DW.stan - ISNULL(PWR.stan,0.0)) as decimal(24,6)) < 0.0"

	rsDW.Open(sSQL,xConn)
	if rsDW.RecordCount() then
		while !rsDW.EOF()
			lCount+=1
			WriteStatusBar(using "Sprawdzenie stanw handlowych...=%d%%%%,255",lCount/rsDW.RecordCount()*100)
			sAsk = using "Stan handlowy '%s' powiza dostawy '%s' o id=%l jest mniejszy od zera.", rsDW.Fields("kod").Value, rsDW.Fields("dwkod").Value, rsDW.Fields("id").Value
			TextOut(sAsk)
			rsDW.MoveNext()
		wend
		if lCount then TextOut("Konieczna diagnostyka tabeli PW")
	endif
	rsDW.Close() : lCount=0

	sSQL =  "select (DW.stan - ISNULL(PWR.stan,0.0)) as pwiloscdosp, DW.iloscdosp as dwiloscdosp, DW.id, DW.kod as dwkod, TW.kod "
	sSQL += "from DW join TW on DW.idtw = TW.id " 
	sSQL += "left join (select SUM(PW.ilosc) as stan, PW.iddw, PW.idtw from PW where PW.typ = 26 group by PW.iddw, PW.idtw) as PWR on (PWR.iddw = DW.id and PWR.idtw = DW.idtw) "
	sSQL += "where (DW.numer < 0 or CAST((DW.stan - ISNULL(PWR.stan,0.0)) as decimal(24,6)) >= 0.0) and  "
	sSQL += "      CAST((DW.stan - DW.iloscdosp - ISNULL(PWR.stan,0.0)) as decimal(24,6)) <> 0.0"

	rsDW.Open(sSQL,xConn)
	if rsDW.RecordCount() then
		xCmdAdo.ActiveConnection = xConnTmp
		while !rsDW.EOF()
			lCount+=1
			WriteStatusBar(using "Sprawdzenie stanw handlowych...=%d%%%%,255",lCount/rsDW.RecordCount()*100)
			sAsk = using "Stan do sprzedania towaru '%s' w dostawie '%s' o id=%l wynosi %.6f, a powinien %.6f.", rsDW.Fields("kod").Value, rsDW.Fields("dwkod").Value, rsDW.Fields("id").Value, rsDW.Fields("dwiloscdosp").Value, rsDW.Fields("pwiloscdosp").Value
			if TextOutAndAsk(2, sAsk," Czy naprawi?") then
				sSQL = using "update DW set iloscdosp = %.6f where id = %l", rsDW.Fields("pwiloscdosp").Value, rsDW.Fields("id").Value
				xCmdAdo.CommandText = sSQL
				xCmdAdo.Execute()
				TextOut(using "Zmieniono stan handlowy towaru '%s' w dostawie '%s'.\n",rsDW.Fields("kod").Value, rsDW.Fields("dwkod").Value)
				TextOut(sRepaired)
			else
				TextOut(sNoRepair)
			endif
			rsDW.MoveNext()
		wend
		xCmdAdo.ActiveConnection = xConn
	endif
	rsDW.Close() : lCount=0

	sSQL =  "select DW.id, DW.kod as dwkod, TW.kod "
	sSQL += "from DW join TW on DW.idtw = TW.id " 
	sSQL += "where DW.numer > 0 and (DW.flag & 0x02) = 0 and cast(DW.iloscdosp as decimal(24,6)) < 0.0"

	rsDW.Open(sSQL,xConn)
	if rsDW.RecordCount() then
		while !rsDW.EOF()
			lCount+=1
			WriteStatusBar(using "Sprawdzenie stanw handlowych...=%d%%%%,255",lCount/rsDW.RecordCount()*100)
			sAsk = using "Stan handlowy '%s' w dostawie '%s' o id=%l jest mniejszy od zera.", rsDW.Fields("kod").Value, rsDW.Fields("dwkod").Value, rsDW.Fields("id").Value
			TextOut(sAsk)
			rsDW.MoveNext()
		wend
		if lCount then TextOut("Konieczna diagnostyka tabeli PW")
	endif
	rsDW.Close() : lCount=0

endsub

int sub funWyczerpane()
	TextOutFun("Sprawdzenie wyczerpania dostaw")
	PopUp(1,"Sprawdzenie wyczerpania dostaw")

	sSQL =  "select count(*) as liczba "
	sSQL += "from DW join TW on DW.idtw = TW.id " 
	sSQL += "where DW.typ = 1 and ((DW.numer > 0 and CAST(DW.stan as decimal(24,6)) = 0.0) or (DW.numer < 0 and CAST(DW.iloscdosp as decimal(24,6)) = 0.0))"

	rsDW.Open(sSQL,xConn)
	if rsDW.RecordCount() then
		xCmdAdo.ActiveConnection = xConnTmp
		if rsDW.Fields("liczba").Value != 0 then
			sAsk = using "Znaleziono %l wyczerpanych dostaw, ale nie oznaczononych jako wyczerpane.", rsDW.Fields("liczba").Value
			if TextOutAndAsk(3, sAsk," Czy naprawi?") then
				xCmdAdo.CommandText = "update DW set typ = 0 where DW.typ = 1 and ((DW.numer > 0 and CAST(DW.stan as decimal(24,6)) = 0.0) or (DW.numer < 0 and CAST(DW.iloscdosp as decimal(24,6)) = 0.0))"
				xCmdAdo.Execute()
				TextOut(using "Oznaczono %l dostaw jako wyczerpane.\n",rsDW.Fields("liczba").Value)
				TextOut(sRepaired)
			else
				TextOut(sNoRepair)
			endif
		endif
		xCmdAdo.ActiveConnection = xConn
	endif
	rsDW.Close() : lCount=0

	sSQL =  "select count(*) as liczba "
	sSQL += "from DW join TW on DW.idtw = TW.id " 
	sSQL += "where DW.typ = 0 and ((DW.numer > 0 and CAST(DW.stan as decimal(24,6)) <> 0.0) or (DW.numer < 0 and CAST(DW.iloscdosp as decimal(24,6)) <> 0.0))"

	rsDW.Open(sSQL,xConn)
	if rsDW.RecordCount() then
		xCmdAdo.ActiveConnection = xConnTmp
		if rsDW.Fields("liczba").Value != 0 then
			sAsk = using "Znaleziono %l niewyczerpanych dostaw, ale oznaczonych jako wyczerpane.", rsDW.Fields("liczba").Value
			if TextOutAndAsk(4, sAsk," Czy naprawi?") then
				xCmdAdo.CommandText = "update DW set typ = 1 where DW.typ = 0 and ((DW.numer > 0 and CAST(DW.stan as decimal(24,6)) <> 0.0) or (DW.numer < 0 and CAST(DW.iloscdosp as decimal(24,6)) <> 0.0))"
				xCmdAdo.Execute()
				TextOut(using "Oznaczono %l dostaw jako niewyczerpane.\n",rsDW.Fields("liczba").Value)
				TextOut(sRepaired)
			else
				TextOut(sNoRepair)
			endif
		endif
		xCmdAdo.ActiveConnection = xConn
	endif
	rsDW.Close() : lCount=0

endsub

int sub funIloscPocz()
	TextOutFun("Sprawdzenie iloci przyjcia")
	PopUp(1,"Sprawdzenie iloci pocztkowej dostawy")

	// powizanie z flag 8 - pierwsze tworzce dostaw
	// ilo kopiowana z powizania dla wystawionego albo w buforze (typ <> 26)
	// omijane dostawy oddziaowe flagDwOddzial 0x02
	sSQL =  "select DW.id, DW.kod as dwkod, DW.ilosc as dwilosc, -PW.ilosc as pwilosc "
	sSQL += "from DW join PW on (PW.typ <> 26 and (PW.flag & 8) <> 0 and PW.iddw = DW.id) "
	sSQL += "where (DW.flag & 0x02) = 0 and CAST((DW.ilosc + PW.ilosc) as decimal(24,6)) <> 0.0"

	rsDW.Open(sSQL,xConn)
	if rsDW.RecordCount() then
		xCmdAdo.ActiveConnection = xConnTmp
		while !rsDW.EOF()
			lCount+=1
			WriteStatusBar(using "Sprawdzenie iloci utworzenia dostawy...=%d%%%%,255",lCount/rsDW.RecordCount()*100)
			sAsk = using "Ilo pierwszego przyjcia do dostawy '%s' o id=%l wynosi %.6f, a powinna %.6f.", rsDW.Fields("dwkod").Value, rsDW.Fields("id").Value, rsDW.Fields("dwilosc").Value, rsDW.Fields("pwilosc").Value
				if TextOutAndAsk(5, sAsk," Czy naprawi?") then
				sSQL = using "update DW set ilosc = %.6f where id = %l", rsDW.Fields("pwilosc").Value, rsDW.Fields("id").Value
				xCmdAdo.CommandText = sSQL
				xCmdAdo.Execute()
				TextOut(using "Zmieniono ilo utworzenia dostawy '%s'.\n", rsDW.Fields("dwkod").Value)
				TextOut(sRepaired)
			else
				TextOut(sNoRepair)
			endif
			rsDW.MoveNext()
		wend
		xCmdAdo.ActiveConnection = xConn
	endif
	rsDW.Close() : lCount=0

	PopUp(1,"Sprawdzenie iloci przyjcia dostawy")

	// powizanie z flag 16 - przyjcia do dostawy
	// ilo kopiowana tylko z powiza dla wystawionych dokumentw (typ = 37)
	sSQL =  "select DW.id, DW.kod as dwkod, DW.iloscPz as dwilosc, PWS.ilosc as pwilosc "
	sSQL += "from DW join (select -SUM(PW.ilosc) as ilosc, PW.iddw from PW where PW.typ = 37 and (PW.flag & 16) <> 0 group by PW.iddw) as PWS on PWS.iddw = DW.id "
	sSQL += "where CAST((DW.iloscPz - PWS.ilosc) as decimal(24,6)) <> 0.0"

	rsDW.Open(sSQL,xConn)
	if rsDW.RecordCount() then
		xCmdAdo.ActiveConnection = xConnTmp
		while !rsDW.EOF()
			lCount+=1
			WriteStatusBar(using "Sprawdzenie iloci przyjcia dostawy...=%d%%%%,255",lCount/rsDW.RecordCount()*100)
			sAsk = using "Ilo przyjcia do dostawy '%s' o id=%l wynosi %.6f, a powinna %.6f.", rsDW.Fields("dwkod").Value, rsDW.Fields("id").Value, rsDW.Fields("dwilosc").Value, rsDW.Fields("pwilosc").Value
			if TextOutAndAsk(6, sAsk," Czy naprawi?") then
				sSQL = using "update DW set iloscPz = %.6f where id = %l", rsDW.Fields("pwilosc").Value, rsDW.Fields("id").Value
				xCmdAdo.CommandText = sSQL
				xCmdAdo.Execute()
				TextOut(using "Zmieniono ilo przyjcia dostawy '%s'.\n", rsDW.Fields("dwkod").Value)
				TextOut(sRepaired)
			else
				TextOut(sNoRepair)
			endif
			rsDW.MoveNext()
		wend
		xCmdAdo.ActiveConnection = xConn
	endif
	rsDW.Close() : lCount=0
endsub

int sub funData()
	TextOutFun("Sprawdzenie daty dostaw")
	PopUp(1,"Sprawdzenie daty dostaw")

	sSQL =  "select DW.id, DW.kod as dwkod, DW.data AS dwdata, MZ.data "
	sSQL += "from DW join PW on (PW.iddkmg = DW.iddkpz and PW.iddw = DW.id) "
	sSQL += "join MZ on (PW.typ <> 26 and PW.idmg = MZ.id) " 
	sSQL += "join MG on (MZ.super = MG.id) " 
	sSQL += "where MZ.data <> DW.data AND MG.statusMig <> 1"

	rsDW.Open(sSQL,xConn)
	if rsDW.RecordCount() then
		xCmdAdo.ActiveConnection = xConnTmp
		while !rsDW.EOF()
			lCount+=1
			WriteStatusBar(using "Sprawdzenie daty dostawy z dat pozycji...=%d%%%%,255",lCount/rsDW.RecordCount()*100)
			sAsk = using "Dostaw '%s' o id=%l zapisano z dat '%s', zamiast z dat '%s' pozycji magazynowej tworzcej t dostaw.", rsDW.Fields("dwkod").Value, rsDW.Fields("id").Value, rsDW.Fields("dwdata").Value, rsDW.Fields("data").Value
			if TextOutAndAsk(7, sAsk, " Czy naprawi?") then
				sSQL = using "update DW set data = convert(datetime, '%s', 20) where id = %l", rsDW.Fields("data").Value, rsDW.Fields("id").Value
				xCmdAdo.CommandText = sSQL
				xCmdAdo.Execute()
				TextOut(using "Zmieniono dat dostawy '%s'.\n", rsDW.Fields("dwkod").Value)
				TextOut(sRepaired)
			else
				TextOut(sNoRepair)
			endif
			rsDW.MoveNext()
		wend
		xCmdAdo.ActiveConnection = xConn
	endif
	rsDW.Close() : lCount=0
endsub

int sub funWartosciDostaw()
string sField
	TextOutFun("Sprawdzenie wartoci dostaw")
	PopUp(1,"Sprawdzenie wartoci stanu")

	// sprawdzane tylko powizania dla wystawionych dokumentw (typ = 37)
	// omijane dostawy oddziaowe flagDwOddzial 0x02
	sSQL =  "select PWS.stan as pwstan, DW.id, DW.kod as dwkod, TW.kod "
	sSQL += "from DW join TW on DW.idtw = TW.id " 
	sSQL += "join (select -SUM(PW.wartosc) as stan, PW.iddw, PW.idtw from PW where PW.typ = 37 group by PW.iddw, PW.idtw) as PWS on (PWS.iddw = DW.id and PWS.idtw = DW.idtw) "
	sSQL += "where (DW.flag & 0x02) = 0 and CAST(PWS.stan as decimal(24,2)) < 0.0"

	rsDW.Open(sSQL,xConn)
	if rsDW.RecordCount() then
		while !rsDW.EOF()
			lCount+=1
			WriteStatusBar(using "Sprawdzenie stanw handlowych...=%d%%%%,255",lCount/rsDW.RecordCount()*100)
			sAsk = using "Warto stanu dostawy '%s', id=%l towaru '%s' jest mniejsza od zera.", rsDW.Fields("dwkod").Value, rsDW.Fields("id").Value, rsDW.Fields("kod").Value
			TextOut(sAsk)
			rsDW.MoveNext()
		wend
		if lCount then TextOut("Konieczna diagnostyka tabeli PW")
	endif
	rsDW.Close() : lCount=0

	sSQL =  "select PWS.stan as pwstan, DW.wartoscst as dwstan, DW.id, DW.kod as dwkod, TW.kod "
	sSQL += "from DW join TW on DW.idtw = TW.id " 
	sSQL += "join (select -SUM(PW.wartosc) as stan, PW.iddw, PW.idtw from PW where PW.typ = 37 group by PW.iddw, PW.idtw) as PWS on (PWS.iddw = DW.id and PWS.idtw = DW.idtw) "
	sSQL += "where (DW.flag & 0x02) = 0 and CAST(PWS.stan as decimal(24,2)) >= 0.0 and "
	sSQL += "      CAST((DW.wartoscst - PWS.stan) as decimal(24,2)) <> 0.0"

	rsDW.Open(sSQL,xConn)
	if rsDW.RecordCount() then
		xCmdAdo.ActiveConnection = xConnTmp
		while !rsDW.EOF()
			lCount+=1
			WriteStatusBar(using "Sprawdzenie wartoci stanu...=%d%%%%,255",lCount/rsDW.RecordCount()*100)
			sAsk = using "Warto stanu dostawy '%s' o id = %l wynosi %.2f a powinna %.2f.", rsDW.Fields("dwkod").Value, rsDW.Fields("id").Value, rsDW.Fields("dwstan").Value, rsDW.Fields("pwstan").Value
			if TextOutAndAsk(8,sAsk," Czy naprawi?") then
				sSQL = using "update DW set wartoscst = %.2f where id = %l", rsDW.Fields("pwstan").Value, rsDW.Fields("id").Value
				xCmdAdo.CommandText = sSQL
				xCmdAdo.Execute()
				TextOut(using "Zmieniono warto stanu dostawy '%s'.\n", rsDW.Fields("dwkod").Value)
				TextOut(sRepaired)
			else
				TextOut(sNoRepair)
			endif
			rsDW.MoveNext()
		wend
		xCmdAdo.ActiveConnection = xConn
	endif
	rsDW.Close() : lCount=0

	sSQL =  "select DW.id, DW.kod as dwkod, TW.kod "
	sSQL += "from DW join TW on DW.idtw = TW.id " 
	sSQL += "where (DW.flag & 0x02) = 0 and cast(DW.stan as decimal(24,6)) = 0.0 and cast(DW.wartoscst as decimal(24,2)) <> 0.0"

	rsDW.Open(sSQL,xConn)
	if rsDW.RecordCount() then
		while !rsDW.EOF()
			lCount+=1
			WriteStatusBar(using "Sprawdzenie wartoci stanu...=%d%%%%,255",lCount/rsDW.RecordCount()*100)
			sAsk = using "Warto stanu dostawy '%s', id=%l towaru '%s' jest niezerowa, podczas gdy jej stan magazynowy jest zerowy.", rsDW.Fields("dwkod").Value, rsDW.Fields("id").Value, rsDW.Fields("kod").Value
			TextOut(sAsk)
			rsDW.MoveNext()
		wend
		if lCount then TextOut("Konieczna diagnostyka tabeli PW")
	endif
	rsDW.Close() : lCount=0

	PopUp(1,"Sprawdzenie wartoci do sprzeday")

	// pomijamy powizania z dokumentami przyjcia magazynowego w buforze (typ = 39)
	sSQL =  "select PWS.stan as pwstan, DW.id, DW.kod as dwkod, TW.kod "
	sSQL += "from DW join TW on DW.idtw = TW.id " 
	sSQL += "join (select -SUM(PW.wartosc) as stan, PW.iddw, PW.idtw from PW where PW.typ <> 39 group by PW.iddw, PW.idtw) as PWS on (PWS.iddw = DW.id and PWS.idtw = DW.idtw) "
	sSQL += "where (DW.flag & 0x02) = 0 and CAST(PWS.stan as decimal(24,2)) < 0.0"

	rsDW.Open(sSQL,xConn)
	if rsDW.RecordCount() then
		while !rsDW.EOF()
			lCount+=1
			WriteStatusBar(using "Sprawdzenie stanw handlowych...=%d%%%%,255",lCount/rsDW.RecordCount()*100)
			sAsk = using "Warto do sprzeday dostawy '%s', id=%l towaru '%s' jest mniejsza od zera.", rsDW.Fields("kod").Value, rsDW.Fields("id").Value, rsDW.Fields("kod").Value
			TextOut(sAsk)
			rsDW.MoveNext()
		wend
		if lCount then TextOut("Konieczna diagnostyka tabeli PW")
	endif
	rsDW.Close() : lCount=0

	sSQL =  "select PWS.stan as pwstan, DW.wartoscdosp as dwstan, DW.id, DW.kod as dwkod, TW.kod "
	sSQL += "from DW join TW on DW.idtw = TW.id " 
	sSQL += "join (select -SUM(PW.wartosc) as stan, PW.iddw, PW.idtw from PW where PW.typ <> 39 group by PW.iddw, PW.idtw) as PWS on (PWS.iddw = DW.id and PWS.idtw = DW.idtw) "
	sSQL += "where (DW.flag & 0x02) = 0 and CAST(PWS.stan as decimal(24,2)) >= 0.0 and "
	sSQL += "      CAST((DW.wartoscdosp - PWS.stan) as decimal(24,2)) <> 0.0"

	rsDW.Open(sSQL,xConn)
	if rsDW.RecordCount() then
		xCmdAdo.ActiveConnection = xConnTmp
		while !rsDW.EOF()
			lCount+=1
			WriteStatusBar(using "Sprawdzenie wartoci do sprzeday...=%d%%%%,255",lCount/rsDW.RecordCount()*100)
			sAsk = using "Warto do sprzeday dostawy '%s' o id = %l wynosi %.2f a powinna %.2f.", rsDW.fields("dwkod").Value, rsDW.fields("id").Value, rsDW.Fields("dwstan").Value, rsDW.Fields("pwstan").Value
			if TextOutAndAsk(9, sAsk," Czy naprawi?") then
				sSQL = using "update DW set wartoscdosp = %.2f where id = %l", rsDW.Fields("pwstan").Value, rsDW.Fields("id").Value
				xCmdAdo.CommandText = sSQL
				xCmdAdo.Execute()
				TextOut(using "Zmieniono warto do sprzeday dostawy '%s'.\n", rsDW.Fields("dwkod").Value)
				TextOut(sRepaired)
			else
				TextOut(sNoRepair)
			endif
			rsDW.MoveNext()
		wend
		xCmdAdo.ActiveConnection = xConn
	endif
	rsDW.Close() : lCount=0

	sSQL =  "select DW.id, DW.kod as dwkod, TW.kod "
	sSQL += "from DW join TW on DW.idtw = TW.id " 
	sSQL += "where (DW.flag & 0x02) = 0 and cast(DW.iloscdosp as decimal(24,6)) = 0.0 and cast(DW.wartoscdosp as decimal(24,2)) <> 0.0"

	rsDW.Open(sSQL,xConn)
	if rsDW.RecordCount() then
		while !rsDW.EOF()
			lCount+=1
			WriteStatusBar(using "Sprawdzenie wartoci do sprzeday...=%d%%%%,255",lCount/rsDW.RecordCount()*100)
			sAsk = using "Warto do sprzeday dostawy '%s', id=%l towaru '%s' jest niezerowa, podczas gdy jej ilo do sprzeday jest zerowa.", rsDW.Fields("dwkod").Value, rsDW.Fields("id").Value, rsDW.Fields("kod").Value
			TextOut(sAsk)
			rsDW.MoveNext()
		wend
		if lCount then TextOut("Konieczna diagnostyka tabeli PW")
	endif
	rsDW.Close() : lCount=0

endsub

int sub funCena()
	TextOutFun("Sprawdzenie ceny dostaw")
	PopUp(1,"Sprawdzenie ceny stanu")

	// cena okrelana na podstawie przyj magazynowych 
	// (gdy nie ma przeceny wartoci magazynu sumowane iloci i wartoci przyjcia i korekt przyjcia)
	// albo ostatniej przeceny wartoci magazynu
	
	// 1. suma iloci i wartoci rekordw PW przyjcia, nie uwzgldnia korekt do zera, pomija dostawy przecenione
	// 2. ilo i warto przyjcia najpniejszej przeceny (max PW.id), uwzgldnia tylko dostawy przecenione

	sSQL =  "select DW.id, DW.kod as dwkod, DW.cena, PWS.wartosc/PWS.ilosc as pwcena "
	sSQL += "from DW "
	sSQL += "join "
	sSQL += "(select MIN(PW.id) as id, PW.iddw, SUM(PW.wartosc) as wartosc, SUM(PW.ilosc) as ilosc "
 	sSQL += " from PW where PW.typ = 37 and PW.subtyp in (74,75,81,82,83,89) "
	sSQL += " group by PW.iddw having SUM(PW.ilosc) <> 0.0) as PWS on PWS.iddw = DW.id "
	sSQL += "where (DW.flag & 0x02) = 0 and DW.id not in "
	sSQL += "(select distinct PW.iddw from PW where PW.subtyp = 91) "
	sSQL += "and cast((DW.cena - PWS.wartosc/PWS.ilosc) as decimal (24,6)) <> 0.0 "
	sSQL += "union "
	sSQL += "select DW.id, DW.kod as dwkod, DW.cena, PWK.wartosc/PWK.ilosc as pwcena "
	sSQL += "from DW "
	sSQL += "join "
	sSQL += "(select MAX(PW.id) as id, PW.iddw "
	sSQL += " from PW where PW.subtyp = 91 and PW.ilosc < 0.0 group by PW.iddw) as PWD on PWD.iddw = DW.id "
	sSQL += "join "
	sSQL += "(select PW.id, PW.iddw, PW.ilosc, PW.wartosc "
	sSQL += " from PW where PW.subtyp = 91 and PW.ilosc < 0.0) as PWK on PWK.iddw = DW.id and PWK.id = PWD.id "
	sSQL += "where (DW.flag & 0x02) = 0 and DW.id in "
	sSQL += "(select distinct PW.iddw from PW where PW.subtyp = 91) "
	sSQL += "and cast((DW.cena - PWK.wartosc/PWK.ilosc) as decimal (24,6)) <> 0.0 "

	rsDW.Open(sSQL,xConn)
	if rsDW.RecordCount() then
		xCmdAdo.ActiveConnection = xConnTmp
		while !rsDW.EOF()
			lCount+=1
			WriteStatusBar(using "Sprawdzenie ceny dostaw...=%d%%%%,255",lCount/rsDW.RecordCount()*100)
			sAsk = using "Cena dostawy dostawy '%s', id=%l wynosi %.6f a powinna %.6f.", rsDW.Fields("dwkod").Value, rsDW.Fields("id").Value, rsDW.Fields("cena").Value, rsDW.Fields("pwcena").Value
			if TextOutAndAsk(10, sAsk," Czy naprawi?") then
				sSQL = using "update DW set cena = %.6f where id = %l", rsDW.Fields("pwcena").Value, rsDW.Fields("id").Value
				xCmdAdo.CommandText = sSQL
				xCmdAdo.Execute()
				TextOut(using "Zmieniono cen dostawy '%s'.\n", rsDW.Fields("dwkod").Value)
				TextOut(sRepaired)
			else
				TextOut(sNoRepair)
			endif
			rsDW.MoveNext()
		wend
		xCmdAdo.ActiveConnection = xConn
	endif
	rsDW.Close() : lCount=0

endsub

int sub funDostawyIlosciowe()
long nLiczba
	TextOutFun("Sprawdzenie dostaw ilociowych")
	PopUp(1,"Sprawdzenie dostaw ilociowych")

	// rezerwcje ilociowe numer < 0 i nie oddziaowe 
 	sSQL  = "select MIN(DW.id) as id, idtw, magazyn "
	sSQL += "into #BDW "
	sSQL += "from DW where DW.numer < 0 group by idtw, magazyn having count (*) > 1 "

	xCmdAdo.CommandText = sSQL
	xCmdAdo.Execute()

	sSQL =  "select count(*) as liczba from DW join "
 	sSQL += "#BDW as DWR on DWR.idtw = DW.idtw and DWR.magazyn = DW.magazyn "
	sSQL += "where DW.numer < 0 and DW.id != DWR.id"

	rsDW.Open(sSQL,xConn)
	if rsDW.RecordCount() then
		if rsDW.Fields("liczba").Value != 0 then
			nLiczba = rsDW.Fields("liczba").Value
			rsDW.Close()
			sAsk = using "Znaleziono %l zdublowanych dostaw ilociowych.", nLiczba
			if TextOutAndAsk(11, sAsk," Czy usun?") then
				xConn.BeginTrans()

				// przepinamy powizania na dostawy ilociowe, ktre maj zosta
				sSQL =  "update PW set iddw = DWC.iddw "
 				sSQL += "from PW join "
 				sSQL += "(select DW.id, DWR.id as iddw "
 				sSQL += " from DW join #BDW as DWR on DWR.idtw = DW.idtw and DWR.magazyn = DW.magazyn "
 				sSQL += " where DW.numer < 0 and DW.id != DWR.id) as DWC on PW.iddw = DWC.id"

				xCmdAdo.CommandText = sSQL
				xCmdAdo.Execute()

				// aktualizujemy ilo w dostawach ilociowych, ktre maj zosta
				sSQL =  "update DW set iloscdosp = DWS.iloscdosp "
 				sSQL += "from DW join #BDW as DWR on DW.id = DWR.id join "
 				sSQL += "(select SUM(DW.iloscdosp) as iloscdosp, idtw, magazyn from DW where DW.numer < 0 group by idtw, magazyn having count (*) > 1) as DWS "
  				sSQL += " on DW.magazyn = DWS.magazyn and DW.idtw = DWS.idtw "
 				sSQL += "where DW.iloscdosp <> DWS.iloscdosp"

				xCmdAdo.CommandText = sSQL
				xCmdAdo.Execute()

				// usuwamy powizania z dostawami ilociowymi przez iddw
				sSQL =  "update DW set iddw = NULL from DW join DW as DWI on DW.iddw = DWI.id where DWI.numer < 0 and (DWI.flag & 0x02) = 0 "

				xCmdAdo.CommandText = sSQL
				xCmdAdo.Execute()

				// usuwamy niepotzrebne dostawy ilociowe
				sSQL =  "delete from DW where id in "
 				sSQL += "(select DW.id from DW join #BDW as DWR on DWR.idtw = DW.idtw and DWR.magazyn = DW.magazyn "
 				sSQL += " where DW.numer < 0 and DW.id != DWR.id)"

				xCmdAdo.CommandText = sSQL
				xCmdAdo.Execute()

				xConn.CommitTrans()

				TextOut(using "Usunito %l zdublowanych dostaw ilociowych.\n",nLiczba)
				TextOut(sRepaired)
			else
				TextOut(sNoRepair)
			endif
		else
			rsDW.Close()
		endif
	else
		rsDW.Close() 
	endif
	lCount=0

	xCmdAdo.CommandText = "drop table #BDW"
	xCmdAdo.Execute()

endsub

int sub funDostawyPrzesuniecia()

	TextOutFun("Sprawdzenie dostaw przesunicia")
	PopUp(1,"Sprawdzenie dostaw przesunicia")

	sAsk = "Znaleziono dostawy przesunicia z niewaciwym towarem."

	sSQL =  " select DW.id, DW.kod as dwkod "
	sSQL += " into #BDW "
	sSQL += " from DW join DW as DWD on DW.iddw = DWD.id where DW.idtw <> DWD.idtw "

	xCmdAdo.CommandText = sSQL
	xCmdAdo.Execute()

	sSQL = "select #BDW.id, #BDW.dwkod from #BDW"

	rsDW.Open(sSQL,xConn)
	if !rsDW.EOF() then
		TextOut(sAsk)
		while !rsDW.EOF()
			lCount+=1
			WriteStatusBar(using "Sprawdzenie dostwa przesunicia...=%d%%%%,255",lCount/rsDW.RecordCount()*100)
			sOut = using "Dostawa %s:%l.", rsDW.Fields("dwkod").Value, rsDW.Fields("id").Value
			TextOut(sOut)
			rsDW.MoveNext()
		wend
	endif
	rsDW.Close()

	if lCount then
		if TextOutAndAsk(12, sAsk," Czy naprawi?") then
			
			sSQL =  " update DW set iddw = NULL from #BDW where #BDW.id = DW.id "

			xCmdAdo.CommandText = sSQL
			xCmdAdo.Execute()
			TextOut(sRepaired)
		else
			TextOut(sNoRepair)
		endif
	endif
	lCount = 0
	
	xCmdAdo.CommandText = "drop table #BDW"
	xCmdAdo.Execute()

endsub

int sub funHistoriaDostaw()

	TextOutFun("Sprawdzenie historii dostaw")
	PopUp(1,"Sprawdzenie historii dostaw")

	sAsk = "Znaleziono dostawy z niewaciw histori."

	sSQL =  " select distinct DWT.iddw "
	sSQL += " into #BDW "
	sSQL += " from PW join (select distinct iddw, data from PW where PW.typ = 37) as DWT on PW.data <= DWT.data and DWT.iddw = PW.iddw "
	sSQL += " where PW.typ = 37 "
	sSQL += " group by DWT.iddw, DWT.data "
	sSQL += " having round(SUM(PW.ilosc),6) > 0.0 "

	xCmdAdo.CommandText = sSQL
	xCmdAdo.Execute()

	sSQL  = " select MG.kod as kodmg, MG.id as idmg, MG.data, TW.kod as towar, MZ.lp, DW.id as iddw, DW.kod as koddw "
	sSQL += " from #BDW "
	sSQL += " join DW on DW.id = #BDW.iddw "
	sSQL += " join MG on DW.iddkpz = MG.id "
	sSQL += " join TW on DW.idtw = TW.id "
	sSQL += " join MZ on MG.id = MZ.super and MZ.idtw = TW.id "
	sSQL += " where (DW.flag & 0x02) = 0 order by MG.data, MG.kod, MZ.lp "

	rsDW.Open(sSQL,xConn)
	if !rsDW.EOF() then
		TextOut(sAsk)
		while !rsDW.EOF()
			lCount+=1
			WriteStatusBar(using "Sprawdzenie historii dostw...=%d%%%%,255",lCount/rsDW.RecordCount()*100)
			sOut = using "Dokument %s:%l, lp:%d", rsDW.Fields("kodmg").Value, rsDW.Fields("idmg").Value, rsDW.Fields("lp").Value
			TextOut(sOut)
			sOut = using "\ttowar: %s, dostawa: %s:%l", rsDW.Fields("towar").Value, rsDW.Fields("koddw").Value, rsDW.Fields("iddw").Value
			TextOut(sOut)
			rsDW.MoveNext()
		wend
	endif
	rsDW.Close()
	lCount = 0
	
	xCmdAdo.CommandText = "drop table #BDW"
	xCmdAdo.Execute()

endsub

int sub funPierwszePrzyjecie()

	TextOutFun("Sprawdzenie pierwszego przyjcia w dostaw")
	PopUp(1,"Sprawdzenie pierwszego przyjcia w dostaw")

	sAsk = "Znaleziono dostawy z niewaciw dat pierwszego przyjcia."

	sSQL =  " select distinct PW.iddw, PW.iddkmg, PW.data "
	sSQL += " into #BDW "
	sSQL += " from DW join PW on DW.id = PW.iddw where (PW.flag & 0x08) <> 0 and PW.iddkmg <> DW.iddkpz and (DW.flag & 0x02) = 0 "

	xCmdAdo.CommandText = sSQL
	xCmdAdo.Execute()

	sSQL  = " select MG.kod as kodmg, MG.id as idmg, MG.data, TW.kod as towar, MZ.lp, DW.id as iddw, DW.kod as koddw "
	sSQL += " from #BDW "
	sSQL += " join DW on DW.id = #BDW.iddw "
	sSQL += " join MG on DW.iddkpz = MG.id "
	sSQL += " join TW on DW.idtw = TW.id "
	sSQL += " join MZ on MG.id = MZ.super and MZ.idtw = TW.id "
	sSQL += " order by MG.data, MG.kod, MZ.lp "

	rsDW.Open(sSQL,xConn)
	if !rsDW.EOF() then
		TextOut(sAsk)
		while !rsDW.EOF()
			lCount+=1
			WriteStatusBar(using "Sprawdzenie daty pierwszego przyjcia...=%d%%%%,255",lCount/rsDW.RecordCount()*100)
			sOut = using "Dokument %s:%l, lp:%d", rsDW.Fields("kodmg").Value, rsDW.Fields("idmg").Value, rsDW.Fields("lp").Value
			TextOut(sOut)
			sOut = using "\ttowar: %s, dostawa: %s:%l", rsDW.Fields("towar").Value, rsDW.Fields("koddw").Value, rsDW.Fields("iddw").Value
			TextOut(sOut)
			rsDW.MoveNext()
		wend
	endif
	rsDW.Close()

	if lCount then
		if TextOutAndAsk(13, sAsk," Czy naprawi?") then
			
			sSQL = " update DW set iddkpz = BDW.iddkmg, data = BDW.data from DW join #BDW as BDW on BDW.iddw = DW.id "

			xCmdAdo.CommandText = sSQL
			xCmdAdo.Execute()

			TextOut(sRepaired)
		else
			TextOut(sNoRepair)
		endif
	endif
	lCount = 0

	xCmdAdo.CommandText = "drop table #BDW"
	xCmdAdo.Execute()

endsub

int sub funDoklWartosc()
	TextOutFun("Sprawdzenie dokadnoci wartoci")
	PopUp(1,"Sprawdzenie dokadnoci wartoci")

	sSQL =  "select count(*) as liczba from DW where Round(DW.wartoscdosp,6) <> Round(DW.wartoscdosp,2) or Round(DW.wartoscst,6) <> Round(DW.wartoscst,2) "

	rsDW.Open(sSQL,xConn)
	if rsDW.RecordCount() then
		if rsDW.Fields("liczba").Value != 0 then
			rsDW.Close()
			sAsk = using "Znaleziono %l dostaw z wartoci nie zaokrglon do 1 gr.", rsDW.Fields("liczba").Value
			if TextOutAndAsk(13, sAsk," Czy naprawi?") then
				xCmdAdo.CommandText = "update DW set wartoscdosp = Round(DW.wartoscdosp,2), wartoscst = Round(DW.wartoscst,2) from DW where Round(DW.wartoscdosp,6) <> Round(DW.wartoscdosp,2) or Round(DW.wartoscst,6) <> Round(DW.wartoscst,2) "
				xCmdAdo.Execute()
				TextOut(using "Zaokrglono wartoci %l powiza.\n",rsDW.Fields("liczba").Value)
				TextOut(sRepaired)
			else
				TextOut(sNoRepair)
			endif
		else
			rsDW.Close()
		endif
	else
		rsDW.Close()
	endif
	lCount=0
endsub

//------------------------------------------------------------------------------------------------------------------------------------

if StageT(1) then 
	funTowary()
	funStany()
	funStanyHandlowe()
	funWyczerpane()
endif
StageSummary(1)
if StageT(2) then 
	funDoklWartosc()
	funWartosciDostaw()
endif
StageSummary(2)
if StageT(3) then 
	funPierwszePrzyjecie()
	funIloscPocz()
	funData()
endif
StageSummary(3)
if StageT(4) then 
//	funCena()
endif
StageSummary(5)
if StageT(5) then 
	funDostawyIlosciowe()
endif
StageSummary(5)
if StageT(6) then 
	funDostawyPrzesuniecia()
endif
StageSummary(6)
if StageT(7) then 
	funHistoriaDostaw()
endif
StageSummary(7)

TextOut("\nZakoczono.")

ShowFileInfo()

